#include	<stdio.h>
#include	<sys/file.h>
#include	"defs.h"
#include	"global.h"

SearchFontFile(fe, direct)
	register struct font_entry *fe;
	char *direct;
{
	char *tcp, *tcp1;
	char curarea[STRSIZE];
	char *index();
    
	if (fe->a != 0) {
		if(FindFont(fe, ""))
			return(TRUE);
	} else {
		do { 
			tcp = index(direct, ':');
			if (tcp == NULL) tcp = strlen(direct) + direct;
			strncpy(curarea, direct, tcp-direct);
			tcp1 = curarea + (tcp - direct);
			*tcp1++ = '/';
			*tcp1++ = '\0';
			
			if(FindFont(fe, curarea))
				return(TRUE);
			if (*tcp)
				direct = tcp + 1;
			else
				direct = tcp;
		} while (*direct != '\0');
	}
	fprintf(stderr, "No font file for %s (pk %d)\n", fe->n, fix(fe->font_mag));
	return(FALSE);
}

FindFont(fe, area)
	register struct font_entry *fe;
	char *area;
{
	int pkmag, pxlmag;
	char name[STRSIZE];
	
	pkmag = fix(fe->font_mag);
	sprintf(name, "%s%s.%dpk", area, fe->n, pkmag);
	if(access(name, R_OK) == 0) {	/* PK file exists */
		fe->font_type = FT_PK;
		fe->dic_pack = psfdicpack(fe);
		strcpy(fe->name, name);
		return(TRUE);
	}
	pxlmag = fix(fe->font_mag * 5.0);
	sprintf(name, "%s%s.%dpxl", area, fe->n, pxlmag);
	if(access(name, R_OK) == 0) {	/* PXL file exists */
		fe->font_type = FT_PXL;
		fe->dic_pack = psfdicpack(fe);
		strcpy(fe->name, name);
		return(TRUE);
	}
	sprintf(name, "%s%s.lwtex", area, fe->n);
	if(access(name, R_OK) == 0) {	/* use LW built-in font */
		fe->font_type = FT_LWTEX;
		strcpy(fe->name, name);
		return(TRUE);
	}
	sprintf(name, "%s%s.lw", area, fe->n);
	if(access(name, R_OK) == 0) {	/* use LW built-in font */
		fe->font_type = FT_LW;
		strcpy(fe->name, name);
		return(TRUE);
	}
	return(FALSE);
}

psfdicpack(fe)
	register struct font_entry *fe;
{
	return(!strncmp(fe->n, "jis", 3) ||
	       !strncmp(fe->n, "dm", 2) || !strncmp(fe->n, "dg", 2));
}
